package pps.core.common.provider.impl;

import com.google.common.base.Strings;
import pps.core.common.cache.ConfigCache;
import pps.core.common.utils.CounterBuilder;
import xstartup.annotation.XImplement;
import xstartup.base.XContext;
import xstartup.kernel.system.provider.spec.XConfigProvider;

/**
 * @author lixueyan
 * @date 2022/8/5 0005 17:11
 */
@XImplement
public class PpsConfigProviderCommonImpl implements XConfigProvider {

    @Override
    public String findValue(XContext context, String config, String app, String key) {
        //todo 实现自定义配置逻辑， 优先级 从低到高  数据库->properties文件
        //从Properties文件中加载配置值
        String configKey = config + "." + key;
        String configKeyWithAppName = config + "." + app + "." + key;
        String configValue = context.getProperty(configKeyWithAppName);
        if (Strings.isNullOrEmpty(configValue)) {
            configValue = context.getProperty(configKey);
        }
        //加载缓存
        final String configValue_ = configValue;
        ConfigCache configCache = ConfigCache.get(context, configKey, false, () -> {
            try {
                CounterBuilder.globalCounterBuilder.addCounter("getConfig-Failed-" + configKey);
                // 使用Properties配置文件配置
                return configValue_;
            } catch (Exception ex) {
                CounterBuilder.globalCounterBuilder.addCounter(ex, this.getClass());
                return configValue_;
            }
        });
        //返回缓存缺省值
        return configCache == null ? configValue_ : configCache.getConfigValue();
    }
}
